//-----------------------------------------------------------------------------
//  (c) 2006 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
Test the implementation of the Converter
*/

#ifndef _CONVERTERTESTSUITE_H_
#define _CONVERTERTESTSUITE_H_

#include "GenApiTest.h"

class ConverterTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( ConverterTestSuite  );
        CPPUNITEX_TEST( TestSlope );
        CPPUNITEX_TEST( TestReadModifyWrite );
        CPPUNITEX_TEST( TestReadModifyWriteInt );
        CPPUNITEX_TEST( TestPixelFormat );
        CPPUNITEX_TEST( TestAutomatic );
        CPPUNITEX_TEST( TestIntAutomatic );
        CPPUNITEX_TEST( TestInvalidFormulas );
        CPPUNITEX_TEST( TestUseTOinFROM );
        CPPUNITEX_TEST( TestFormulaProperty );
        CPPUNITEX_TEST( TestConstantAndExpression );
        CPPUNITEX_TEST( TestCaseInsensitive );
        CPPUNITEX_TEST( TestLimits );
        CPPUNITEX_TEST( TestUpperLowerCase );
    CPPUNIT_TEST_SUITE_END();

public:
  void TestPixelFormat();
  void TestReadModifyWrite();
  void TestReadModifyWriteInt();
  void TestSlope();
  void TestAutomatic();
  void TestIntAutomatic();
  void TestInvalidFormulas();
  void TestUseTOinFROM();
  void TestFormulaProperty();
  void TestConstantAndExpression();
  void TestLimits();
  void TestCaseInsensitive();
  void TestUpperLowerCase();


};
#endif
