//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/

#ifdef _MSC_VER
#   include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#endif

#include "ExceptionTest.h"
#include "GenApi/GenApi.h"

using namespace std;
using namespace GenICam;
using namespace GenApi;

CPPUNIT_TEST_SUITE_REGISTRATION( ExceptionTestSuite );




void ExceptionTestSuite::TestException()
{
    char pcDesc[] = "ErrorDEscription";
    char pcSourceFileName[] = ".\\MyFile.cpp";
    unsigned int nSourceLine = 9;

    GenericException MyException(pcDesc, pcSourceFileName, nSourceLine);

    CPPUNIT_ASSERT_EQUAL((gcstring)MyException.GetDescription(), (gcstring)pcDesc);
    CPPUNIT_ASSERT_EQUAL((gcstring)MyException.GetSourceFileName(), (gcstring)pcSourceFileName);
    CPPUNIT_ASSERT_EQUAL(MyException.GetSourceLine(), nSourceLine);


    // test exception reporting using stringstream
    stringstream sstr;
    sstr << "x" << "y";
    gcstring ExceptionDesc;
    try
    {
        throw RUNTIME_EXCEPTION( sstr ) ;
    }
    catch(GenericException &e)
    {
        ExceptionDesc = e.GetDescription();
    }
    CPPUNIT_ASSERT_EQUAL(ExceptionDesc, (gcstring)"xy");
}






