//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef __FILESTREAMTEST_H
#define __FILESTREAMTEST_H

#include "GenApiTest.h"

/**
\brief Tests node persistence
*/
class FilestreamTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( FilestreamTestSuite  );
        CPPUNITEX_TEST( TestFileStreamNotExist );
        CPPUNITEX_TEST( TestFileStreamLUTAccessBufferSmaller );
        CPPUNITEX_TEST( TestFileStreamLUTAccessBufferEqual );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests FileStream Adapter on an XML were the Nodes are Missing
    void TestFileStreamNotExist ();
    //! Tests FileStream Adapter on an XML that exposes the LUT through the FileInterface with a filebuffer smaller than complete lut
    void TestFileStreamLUTAccessBufferSmaller ();
    //! Tests FileStream Adapter on an XML that exposes the LUT through the FileInterface with a filebuffer equal to complete lut
    void TestFileStreamLUTAccessBufferEqual ();



};

#endif // __FILESTREAMTEST_H
