//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INDEXEDINTEGERTEST_H
#define __INDEXEDINTEGERTEST_H

#include "GenApiTest.h"

/**
\brief Tests CIntReg
*/
class IndexedIntegerTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IndexedIntegerTestSuite );
        CPPUNITEX_TEST( TestMultiplexerMode );
        CPPUNITEX_TEST( TestPolymorphicalIntegerAccess );
        CPPUNITEX_TEST( TestIndexedAccess );
        CPPUNITEX_TEST( TestAccessMode );
    CPPUNIT_TEST_SUITE_END();

public:
    //! tests the multiplexer functionality
    void TestMultiplexerMode();

    //! Tests the PolyPointer inside the Integer node
    void TestPolymorphicalIntegerAccess();

    //! Tests the indexed access
    void TestIndexedAccess();

    //! Tests the access mode
    void TestAccessMode();
};

#endif // __INDEXEDINTEGERTEST_H
