//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INTSWISSKNIFETEST_H
#define __INTSWISSKNIFETEST_H

#include "GenApiTest.h"

/**
\brief Tests CIntSwissKnife
*/
class IntSwissKnifeTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IntSwissKnifeTestSuite );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestIntSwissKnifeTrig );//tests trig math functions in IntSwissKnife
        CPPUNITEX_TEST( TestIntSwissKnifeReturnDbl );//tests conversion of double to integer for function results
        CPPUNITEX_TEST( TestIntSwissKnifeVariableMinMax );//tests that variable min/max is validated while parsing
        CPPUNITEX_TEST( TestIntSwissKnifeVariableValue );//tests that the variable value is defined while parsing
        CPPUNITEX_TEST( TestIntSwissKnifeValueType );//tests that the variable value-type is valid while parsing
        CPPUNITEX_TEST( TestIntSwissKnifeArgumentType );//tests that the swissknife supports the given variable type
        CPPUNITEX_TEST( TestVariableDelegates );// Pleora FG: tests some exception cases to complete variable delegates coverage
        CPPUNITEX_TEST( TestInvalidFormulas );
        CPPUNITEX_TEST( TestBig ); // Pleora FG: tests some pretty big Swiss Knives
        CPPUNITEX_TEST( TestVariableNames ); // Mantis #288
        CPPUNITEX_TEST( TestConstantAndExpression );
        CPPUNITEX_TEST( TestVariableExtensions );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the basic get and set methods
    void TestValueAccess();
    void TestIntSwissKnifeTrig();
    void TestIntSwissKnifeReturnDbl();
    void TestIntSwissKnifeVariableMinMax();
    void TestIntSwissKnifeVariableValue();
    void TestIntSwissKnifeValueType();
    void TestIntSwissKnifeArgumentType();
    void TestVariableDelegates();
    void TestInvalidFormulas();
    void TestBig();
    void TestVariableNames();
    void TestConstantAndExpression();
    void TestVariableExtensions();

};

#endif // __INTSWISSKNIFETEST_H
