//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __NODEMAPTEST_H
#define __NODEMAPTEST_H

#include "GenApiTest.h"

/**
\brief Tests CNodeMap
*/
class NodeMapTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( NodeMapTestSuite );
        CPPUNITEX_TEST( TestNodeMap );
        CPPUNITEX_TEST( TestTheRest );
        CPPUNITEX_TEST( TestSchemaLocation );
        CPPUNITEX_TEST( TestWithoutTooltip );
        CPPUNITEX_TEST( TestSchemaVersions );
        CPPUNITEX_TEST( TestExposeStatic );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests basic node map features
    void TestNodeMap();

    //! Tests what is not covered by the functions above
    void TestTheRest();

    //! Tests schema
    void TestSchemaLocation();

    //! Mantis #127
    void TestWithoutTooltip();

    void TestSchemaVersions();

    void TestExposeStatic();
};

#endif // __NODEMAPTEST_H
