//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __PERSISTENCETEST_H
#define __PERSISTENCETEST_H

#include "GenApiTest.h"

/**
\brief Tests node persistence
*/
class PersistenceTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( PersistenceTestSuite );
        CPPUNITEX_TEST( TestSimple );
        CPPUNITEX_TEST( TestSelector );
        CPPUNITEX_TEST( TestAccessMode );
        CPPUNITEX_TEST( TestMisc );
        CPPUNITEX_TEST( FailBit_Mantis356 );
        CPPUNITEX_TEST( LongFeatures_Mantis356 );
        CPPUNITEX_TEST( TestEnumerationSelector );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests simple lists of nodes
    void TestSimple();

    //! Tests selector
    void TestSelector();

   //! Access mode related tests
    void TestAccessMode();

    //! Miscellaneous tests
    void TestMisc();

    //! Test if the fail Bit of a stream is set, even if read operation was OK!
    void FailBit_Mantis356();

    //! Test feature with value attribute containing more than 1024 Bytes
    void LongFeatures_Mantis356();

    //! Test enumeration selector
    void TestEnumerationSelector();
};

#endif // __PERSISTENCETEST_H
