//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __SWISSKNIFETEST_H
#define __SWISSKNIFETEST_H

#include "GenApiTest.h"

#define RUN_CRASHING_TEST 0

/**
\brief Tests CNodeImpl
*/
class SwissKnifeTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( SwissKnifeTestSuite );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestSwissKnife );//black box test, basic math and SwissKnife nesting, tests both knife flavors
        CPPUNITEX_TEST( TestSwissKnifeBrokenBitOps );//tests bit operations in the mathParser that parse incorrectly
        CPPUNITEX_TEST( TestSwissKnifeVariableMinMax );//tests that variable min/max is validated while parsing
        CPPUNITEX_TEST( TestSwissKnifeVariableValue );//tests that the variable value is defined while parsing
        CPPUNITEX_TEST( TestSwissKnifeArgumentType );//tests that the swissknife supports the given variable type
        CPPUNITEX_TEST( TestIntSwissKnifeTrig );//tests trig math functions in IntSwissKnife
        CPPUNITEX_TEST( TestVariableDelegates );// Pleora FG: tests some exception cases to complete variable delegates coverage
        CPPUNITEX_TEST( TestRecursion ); // test recursive nodemaps
        CPPUNITEX_TEST( TestBig ); // Pleora FG: tests huge SwissKnife
        CPPUNITEX_TEST( TestVariableNames ); // Mantis #288
        CPPUNITEX_TEST( VariableNames ); // checks how variables can look like
        CPPUNITEX_TEST( TestConstantAndExpression );
        CPPUNITEX_TEST( TestVariableExtensions ); // tests .Min/.Max extensions to the variable name
    CPPUNIT_TEST_SUITE_END();


public:
    //! Tests the propagation of the access mode
    void TestSwissKnife();
    void TestSwissKnifeBrokenBitOps();
    void TestSwissKnifeVariableMinMax();
    void TestSwissKnifeVariableValue();
    void TestSwissKnifeArgumentType();
    void TestIntSwissKnifeTrig();
    void TestValueAccess();
    void TestVariableDelegates();
    void TestRecursion();
    void TestBig();
    void TestVariableNames();
    void VariableNames();
    void TestConstantAndExpression();
    void TestVariableExtensions();

};

#endif // __SWISSKNIFETEST_H
