//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApi
//  Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
\brief    Defines the entry point for the DLL application.
*/

#ifdef _MSC_VER
#   include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#endif

#include "TestCamera_v1_0DLL.h"

#include "../TestCamera_v1_0Impl.h"

#include "GenApi/GenApiVersion.h"
#include "Base/GCLinkage.h"


#ifdef WIN32

#if defined _MT

    #pragma comment(lib, LIB_NAME( "GCBase"     ) )
    #pragma comment(lib, LIB_NAME( "GenApi"     ) )
    #pragma comment(lib, LIB_NAME( "Log"        ) )
    #pragma comment(lib, LIB_NAME( "MathParser" ) )
    #pragma comment(lib, LIB_NAME( "log4cpp"    ) )

#else
    #error Invalid configuration
#endif


BOOL APIENTRY DllMain( HANDLE /*hModule*/,
                       DWORD  ul_reason_for_call,
                       LPVOID /*lpReserved*/
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}
#endif

GenApi::INodeMap* Create(const char* pDeviceName)
{
    return Test_TestCamera_v1_0::CTestCamera_v1_0Impl::Create(pDeviceName);
}

static Version_t GenApiVersion = {GENAPI_VERSION_MAJOR, GENAPI_VERSION_MINOR, GENAPI_VERSION_SUBMINOR};

void SetGenApiVersion(Version_t const &Version)
{
    GenApiVersion = Version;
}

void GetGenApiVersion(Version_t &Version)
{
    Version = GenApiVersion;
}
