//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApi
//  Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
\brief    no content
*/

#ifndef TESTCAMERADLL_H
#define TESTCAMERADLL_H

#ifdef WIN32
#   include <windows.h>
#endif

#include "GenApi/INodeMap.h"
#include "GenApi/DLLLoad.h"

extern "C"
{
#if defined (_MSC_VER)
    __declspec(dllexport) GenApi::INodeMap* Create(const char* pDeviceName);
    __declspec(dllexport) void GetGenApiVersion(Version_t &Version);
    __declspec(dllexport) void SetGenApiVersion(Version_t const &Version);
#elif defined (__GNUC__)
    GenApi::INodeMap* Create(const char* pDeviceName) __attribute__((visibility("default")));
    void GetGenApiVersion(Version_t &Version) __attribute__((visibility("default")));
    void SetGenApiVersion(Version_t const &Version) __attribute__((visibility("default")));
#else
    GenApi::INodeMap* Create(const char* pDeviceName);
    void GetGenApiVersion(Version_t &Version);
    void SetGenApiVersion(Version_t const &Version);
#endif
}


#endif
