//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/

#ifdef _MSC_VER
#   include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#endif

#include "GenApiTest.h"
#include "TestRegisterPort.h"

using namespace std;
using namespace GenICam;
using namespace GenApi;

GenApi::EAccessMode CTestRegisterPort::GetAccessMode() const
{
    return RW;
}

//! Get the type of the main interface of a node
GenApi::EInterfaceType CTestRegisterPort::GetPrincipalInterfaceType() const
{
    return intfIPort;
}


void CTestRegisterPort::ReadRegister(uint32_t *pRegisters, int64_t Address, int64_t Length)
{
    EAccessMode AccessMode = NI;
    LookupEntry(Address, 4*Length, pRegisters, AccessMode);
    if( !IsReadable(AccessMode) )
        throw RUNTIME_EXCEPTION("Register not quadlet readable at address 0x%llx", Address);
}

void CTestRegisterPort::WriteRegister(const uint32_t *pRegisters, int64_t Address, int64_t Length)
{
    EAccessMode AccessMode = NI;
    UpdateEntry(Address, 4*Length, pRegisters, AccessMode);
    if( !IsWritable(AccessMode) )
        throw RUNTIME_EXCEPTION("Register not quadlet writable at address 0x%llx", Address);
}



